; Program za crtanje sahovske table uz mogucnost izbora boja sahvskih polja
;
; Autor: Ikodinovic Igor


TITLE Chess


Stack_Seg SEGMENT STACK 'STACK'
		  DW 100 DUP(0) ; Rezervise se 100 reci na steku
	Top_Stack LABEL WORD	; Postavljamo pokazivac na vrh steka (da bi
				; kasnije njim inicijalizovali stek pointer)
Stack_Seg ENDS


Data_Seg SEGMENT WORD 'DATA'
	messageERR	DB  "Greska! $"
Data_Seg ENDS


Code_Seg SEGMENT WORD 'CODE'
	ASSUME CS:Code_Seg, DS:Data_Seg, ES:Data_Seg, SS:Stack_Seg

	FIELDWIDTH  EQU 13
	BOARDFIELD  EQU 16
	MAXCOLOR    EQU 16
	_ENTER	    EQU 13
	_LEFT	    EQU 4B00h
	_RIGHT	    EQU 4D00h
	_UP	    EQU 4800h
	_DOWN	    EQU 5000h
	_A	    EQU 65
	_H	    EQU 72
	_1	    EQU 49
	_8	    EQU 56

; Inicijalizacija segmentnih registara i SP

Start:	    mov ax,Stack_Seg	; inicijalizacija SS
	    mov ss,ax
	    mov sp,OFFSET Top_Stack ; inicijalizacija SP
	    mov ax,Data_Seg
	    mov ds,ax		; inicijalizacija DS
	    mov es,ax		; inicijalizacija ES

;********** Izbor boja za sahovsku tablu

	    mov ah,0Fh		; get video mode
	    int 10h		;
	    pushw ax		; cuvamo tekuci video mode na stack-u
	    pushw bx		;

	    mov ah,00h		; postavljamo CGA video mod 320*200 sa 16 boja
	    mov al,0Dh		; pomocu BIOS poziva interaptom 10h i funkcijom
	    int 10h		; 00h za izbor video moda (ovde mod 0Dh)

	    mov si,6d		; inicijalizuje se pozicija (boja) u 1. paleti
	    mov di,15d		; inicijalizuje se pozicija (boja) u 2. paleti

; Crtamo okvir za prvu paletu

frame1:	    mov ah,0Ch
	    mov al,15

gornjaduz1: mov cx,45d
	    mov dx,48d
nextpixel1: int 10h
	    cmp cx,257d
	    je	donjaduz1
	    inc cx
	    jmp nextpixel1

donjaduz1:  mov cx,45d
	    mov dx,71d
nextpixel2: int 10h
	    cmp cx,257d
	    je	levaduz1
	    inc cx
	    jmp nextpixel2

levaduz1:   mov cx,45d
	    mov dx,48d
nextpixel3: int 10h
	    cmp dx,71d
	    je desnaduz1
	    inc dx
	    jmp nextpixel3

desnaduz1:  mov cx,257d
	    mov dx,48d
nextpixel4: int 10h
	    cmp dx,71d
	    je	paleta1
	    inc dx
	    jmp nextpixel4

; Crtamo paletu sa bojama za jedno sahovsko polje

paleta1:    mov dx,51d		; DX = y koordinata
	    mov bl,FIELDWIDTH	;
nextline5:  cmp dx,67d		; da li smo iscrtali poslednju liniju
	    je	choice1		; ako jesmo, idemo na drugopolje
	    mov cx,47d		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel5: mov ax,cx		; u AL je boja
	    sub ax,47d		;
	    div bl		;
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    cmp cx,255d		; da li smo iscrtali liniju do kraja
	    je	nextline5	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel5	; idemo na sledeci pixel

; Crtamo istaknuti kvadrat za trenutno izabranu prvu boju

choice1:    mov cx,47d		; postavlja se pocetna x koordinata
	    mov ax,si		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;

	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,48d		; u DX je pocetno y
nextline6:  cmp dx,70d		; da li smo iscrtali poslednju liniju
	    je	frame2		; ako jesmo, crtamo drugu paletu
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel6: mov ax,si		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline6	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel6	; idemo na sledeci pixel

; Crtamo okvir za drugu paletu

frame2:	    mov ah,0Ch
	    mov al,15

gornjaduz2: mov cx,45d
	    mov dx,128d
nextpixel7: int 10h
	    cmp cx,257d
	    je	donjaduz2
	    inc cx
	    jmp nextpixel7

donjaduz2:  mov cx,45d
	    mov dx,151d
nextpixel8: int 10h
	    cmp cx,257d
	    je	levaduz2
	    inc cx
	    jmp nextpixel8

levaduz2:   mov cx,45d
	    mov dx,128d
nextpixel9: int 10h
	    cmp dx,151d
	    je	desnaduz2
	    inc dx
	    jmp nextpixel9

desnaduz2:  mov cx,257d
	    mov dx,128d
nextpixel10:int 10h
	    cmp dx,151d
	    je	paleta2
	    inc dx
	    jmp nextpixel10

; Crtamo paletu sa bojama za drugo sahovsko polje

paleta2:    mov dx,131d		; DX = y koordinata
	    mov bl,FIELDWIDTH	;
nextline11: cmp dx,147d		; da li smo iscrtali poslednju liniju
	    je	choice2		; ako jesmo, idemo na drugopolje
	    mov cx,47d		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel11:mov ax,cx		; u AL je boja
	    sub ax,47d		;
	    div bl		;
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    cmp cx,255d		; da li smo iscrtali liniju do kraja
	    je	nextline11	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel11	; idemo na sledeci pixel

; Crtamo istaknuti kvadrat za trenutno izabranu drugu boju

choice2:    mov cx,47d		; postavlja se pocetna x koordinata
	    mov ax,di		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;

	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,130d		;
	    sub dx,2		; u DX je pocetno y
nextline12: cmp dx,150d		; da li smo iscrtali poslednju liniju
	    je	select1		; ako jesmo, idemo na izbor boje iz palete 1
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel12:mov ax,di		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline12	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel12	; idemo na sledeci pixel

; Crtamo okkvir za selekciju prve palete

select1:    mov ah,0Ch
	    mov al,15

gornjaduz3: mov cx,43d
	    mov dx,46d
nextpixel30:int 10h
	    cmp cx,259d
	    je	donjaduz3
	    inc cx
	    jmp nextpixel30

donjaduz3:  mov cx,43d
	    mov dx,73d
nextpixel31:int 10h
	    cmp cx,259d
	    je	levaduz3
	    inc cx
	    jmp nextpixel31

levaduz3:   mov cx,43d
	    mov dx,46d
nextpixel32:int 10h
	    cmp dx,73d
	    je	desnaduz3
	    inc dx
	    jmp nextpixel32

desnaduz3:  mov cx,259d
	    mov dx,46d
nextpixel33:int 10h
	    cmp dx,73d
	    je	key_1
	    inc dx
	    jmp nextpixel33

; Izbor boje sa prve palete

key_1:	    mov ah,00h		; ocitavanje tastera pomocu BIOS poziva preko
	    int 16h		; interapta 16h i funkcije 00h (ASCII kod
				; znaka je u AL, a u AH je Scan kod)
leftkey_1:  cmp ax,_LEFT	; da li je pritisnut taster LEFT
	    jne rightkey_1	; ako nije idi na rightkey_1
	    cmp si,0		; ako jeste proveri da li smo na levom kraju palete
	    je	key_1		; ako jesmo, ocitaj sledeci pritisnuti taster

	    mov cx,47d		; ako nismo, obrisi staru boju
	    mov ax,si		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,48d		; u DX je pocetno y
nextline13: cmp dx,70d		; da li smo iscrtali poslednju liniju
	    je	redrawl1	; ako jesmo, skoci na redrawl1
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel13:mov ax,0		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline13	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel13	; idemo na sledeci pixel

redrawl1:   mov cx,47d		;
	    mov ax,si		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,51d		; u DX je pocetno y
nextline14: cmp dx,67d		; da li smo iscrtali poslednju liniju
	    je	newcolorl1	; ako jesmo, skoci na newcolorl1
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel14:mov ax,si		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline14	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel14	; idemo na sledeci pixel

newcolorl1: dec si		; pomerimo se levo u paleti

	    mov cx,47d		; crtamo novu boju
	    mov ax,si		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,48d		; u DX je pocetno y
nextline15: cmp dx,70d		; da li smo iscrtali poslednju liniju
	    je	key_1		; ako jesmo, citamo sledecu komandu
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel15:mov ax,si		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline15	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel15	; idemo na sledeci pixel

rightkey_1: cmp ax,_RIGHT	; da li je pritisnut taster RIGHT
	    jne downkey_1	; ako nije idi na downkey_1
	    cmp si,MAXCOLOR-1	; ako jeste proveri da li smo na desnom kraju palete
	    je	key_1		; ako jesmo, ocitaj sledeci pritisnuti taster

	    mov cx,47d		; ako nismo, obrisi staru boju
	    mov ax,si		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,48d		; u DX je pocetno y
nextline16: cmp dx,70d		; da li smo iscrtali poslednju liniju
	    je	redrawr1	; ako jesmo, skoci na redrawr1
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel16:mov ax,0		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline16	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel16	; idemo na sledeci pixel

redrawr1:   mov cx,47d		;
	    mov ax,si		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,51d		; u DX je pocetno y
nextline17: cmp dx,67d		; da li smo iscrtali poslednju liniju
	    je	newcolorr1	; ako jesmo, skoci na newcolorr1
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel17:mov ax,si		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline17	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel17	; idemo na sledeci pixel

newcolorr1: inc si		; pomerimo se desno u paleti

	    mov cx,47d		; crtamo novu boju
	    mov ax,si		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,48d		; u DX je pocetno y
nextline18: cmp dx,70d		; da li smo iscrtali poslednju liniju
	    je	key_1		; ako jesmo, citamo sledecu komandu
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel18:mov ax,si		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline18	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel18	; idemo na sledeci pixel

downkey_1:  cmp ax,_DOWN	; da li je pritisnut taster DOWN
	    jne enterkey_1	; ako nije idi na enterkey_1
				;
	    mov ah,0Ch		; ako jeste izbrisi selekciju palete 1
	    mov al,0		; i selektuj paletu 2
				;
gornjaduz4: mov cx,43d		;
	    mov dx,46d		;
nextpixel34:int 10h		;
	    cmp cx,259d 	;
	    je	donjaduz4	;
	    inc cx		;
	    jmp nextpixel34	;
				;
donjaduz4:  mov cx,43d		;
	    mov dx,73d		;
nextpixel35:int 10h		;
	    cmp cx,259d 	;
	    je	levaduz4	;
	    inc cx		;
	    jmp nextpixel35	;
				;
levaduz4:   mov cx,43d		;
	    mov dx,46d		;
nextpixel36:int 10h		;
	    cmp dx,73d		;
	    je	desnaduz4	;
	    inc dx		;
	    jmp nextpixel36	;
				;
desnaduz4:  mov cx,259d		;
	    mov dx,46d		;
nextpixel37:int 10h		;
	    cmp dx,73d		;
	    je	select2		;
	    inc dx		;
	    jmp nextpixel37	;

enterkey_1: cmp al,_ENTER	; da li je pritisnut taster ENTER
	    jne key_1		; ako nije, znaci da je unet neki znak koji
				; nema funkciju pa citamo sledeci znak
	    cmp si,di		; ako jeste, ispitaj da li su boje iste
	    je	key_1		; ako jesu onda mora da se odabere neka druga
	    jmp tabla		; inace mozemo da crtamo tablu

; Selekcija druge palete

select2:    mov ah,0Ch
	    mov al,15

gornjaduz5: mov cx,43d
	    mov dx,126d
nextpixel38:int 10h
	    cmp cx,259d
	    je	donjaduz5
	    inc cx
	    jmp nextpixel38

donjaduz5:  mov cx,43d
	    mov dx,153d
nextpixel39:int 10h
	    cmp cx,259d
	    je	levaduz5
	    inc cx
	    jmp nextpixel39

levaduz5:   mov cx,43d
	    mov dx,126d
nextpixel40:int 10h
	    cmp dx,153d
	    je	desnaduz5
	    inc dx
	    jmp nextpixel40

desnaduz5:  mov cx,259d
	    mov dx,126d
nextpixel41:int 10h
	    cmp dx,153d
	    je	key_2
	    inc dx
	    jmp nextpixel41

; Izbor boje sa druge palete

key_2:	    mov ah,00h		; ocitavanje tastera pomocu BIOS poziva preko
	    int 16h		; interapta 16h i funkcije 00h (ASCII kod
				; znaka je u AL, a u AH je Scan kod)
leftkey_2:  cmp ax,_LEFT	; da li je pritisnut taster LEFT
	    jne rightkey_2	; ako nije idi na rightkey_2
	    cmp di,0		; ako jeste proveri da li smo na levom kraju palete
	    je	key_2		; ako jesmo, ocitaj sledeci pritisnuti taster

	    mov cx,47d		; ako nismo, obrisi staru boju
	    mov ax,di		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,130d		;
	    sub dx,2		; u DX je pocetno y
nextline19: cmp dx,150d		; da li smo iscrtali poslednju liniju
	    je	redrawl2	; ako jesmo, skoci na redrawl2
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel19:mov ax,0		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline19	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel19	; idemo na sledeci pixel

redrawl2:   mov cx,47d		;
	    mov ax,di		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,131d		; u DX je pocetno y
nextline20: cmp dx,147d		; da li smo iscrtali poslednju liniju
	    je	newcolorl2	; ako jesmo, skoci na newcolorl2
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel20:mov ax,di		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline20	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel20	; idemo na sledeci pixel

newcolorl2: dec di		; ako nismo, pomerimo se levo po paleti

	    mov cx,47d		; crtamo novu boju
	    mov ax,di		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,130d		;
	    sub dx,2		; u DX je pocetno y
nextline21: cmp dx,150d		; da li smo iscrtali poslednju liniju
	    je	key_2		; ako jesmo, citamo sledecu komandu
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel21:mov ax,di		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline21	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel21	; idemo na sledeci pixel

rightkey_2: cmp ax,_RIGHT	; da li je pritisnut taster RIGHT
	    jne upkey_2		; ako nije idi na upkey_2
	    cmp di,MAXCOLOR-1	; ako jeste proveri da li smo na desnom kraju palete
	    je	key_2		; ako jesmo, ocitaj sledeci pritisnuti taster

	    mov cx,47d		; ako nismo, obrisi staru boju
	    mov ax,di		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,130d		;
	    sub dx,2		; u DX je pocetno y
nextline22: cmp dx,150d		; da li smo iscrtali poslednju liniju
	    je	redrawr2	; ako jesmo, skoci na redrawr2
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel22:mov ax,0		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline22	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel22	; idemo na sledeci pixel

redrawr2:   mov cx,47d		;
	    mov ax,di		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,131d		; u DX je pocetno y
nextline23: cmp dx,147d		; da li smo iscrtali poslednju liniju
	    je	newcolorr2	; ako jesmo, skoci na newcolorr2
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel23:mov ax,di		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline23	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel23	; idemo na sledeci pixel

newcolorr2: inc di		; ako nismo, pomerimo se levo po paleti

	    mov cx,47d		; crtamo novu boju
	    mov ax,di		;
	    mov bl,FIELDWIDTH	;
	    mul bl		;
	    add cx,ax		;
	    mov bx,cx		; cuvamo pocetno x u BX
	    mov dx,130d		;
	    sub dx,2		; u DX je pocetno y
nextline24: cmp dx,150d		; da li smo iscrtali poslednju liniju
	    je	key_2		; ako jesmo, citamo sledecu komandu
	    mov cx,bx		; ako nismo, vracamo x na pocetak
	    inc dx		; a y uvecavamo za jedan
nextpixel24:mov ax,di		; u AL je boja
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    mov ax,bx		;
	    add ax,FIELDWIDTH	;
	    dec ax		;
	    cmp cx,ax		; da li smo iscrtali liniju do kraja
	    je	nextline24	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel24	; idemo na sledeci pixel

upkey_2:    cmp ax,_UP		; da li je pritisnut taster UP
	    jne enterkey_2	; ako nije, idi na enterkey_2

	    mov ah,0Ch		; ako jeste izbrisi selekciju palete 2
	    mov al,00		; i selektuj paletu 1
				;
gornjaduz6: mov cx,43d		;
	    mov dx,126d 	;
nextpixel42:int 10h		;
	    cmp cx,259d		;
	    je	donjaduz6	;
	    inc cx		;
	    jmp nextpixel42	;
				;
donjaduz6:  mov cx,43d		;
	    mov dx,153d 	;
nextpixel43:int 10h		;
	    cmp cx,259d		;
	    je	levaduz6	;
	    inc cx		;
	    jmp nextpixel43	;
				;
levaduz6:   mov cx,43d		;
	    mov dx,126d 	;
nextpixel44:int 10h		;
	    cmp dx,153d 	;
	    je	desnaduz6	;
	    inc dx		;
	    jmp nextpixel44	;
				;
desnaduz6:  mov cx,259d		;
	    mov dx,126d 	;
nextpixel45:int 10h		;
	    cmp dx,153d 	;
	    je	select1		;
	    inc dx		;
	    jmp nextpixel45	;

enterkey_2: cmp al,_ENTER	; da li je pritisnut taster ENTER
	    jne key_2		; ako nije, znaci da je unet neki znak koji
				; nema funkciju pa citamo sledeci znak
	    cmp si,di		; ako jeste, ispitaj da li su boje iste
	    je	key_2		; ako jesu onda mora da se odabere neka druga

;********** Crtamo sahovsku tablu

; Brisemo ekran

tabla:	    mov ah,00h		; postavljamo mod 0Dh (320*200, 16 colors)
	    mov al,0Dh		; cime brisemo ekran
	    int 10h		;

; Crtamo okvir table

frame:	    mov ah,0Ch
	    mov al,15

gornjaduz:  mov cx,97d
	    mov dx,33d
nextpixel25:int 10h
	    cmp cx,230d
	    je	donjaduz
	    inc cx
	    jmp nextpixel25

donjaduz:   mov cx,97d
	    mov dx,165d
nextpixel26:int 10h
	    cmp cx,230d
	    je	levaduz
	    inc cx
	    jmp nextpixel26

levaduz:    mov cx,97d
	    mov dx,33d
nextpixel27:int 10h
	    cmp dx,165d
	    je	desnaduz
	    inc dx
	    jmp nextpixel27

desnaduz:   mov cx,230d
	    mov dx,33d
nextpixel28:int 10h
	    cmp dx,165d
	    je	marks
	    inc dx
	    jmp nextpixel28

; Pisemo oznake polja

marks:	    mov bl,2		; namestamo boju oznaka
	    mov cx,1		; broj ponavljanja karaktera pri stampanju
	    mov dl,13d		; x koordinata
	    mov dh,21d		; y koordinata
	    mov al,_A		; u AL je karakter koji se stampa
nextmark1:  mov ah,02h		; namestamo kursor
	    int 10h		;
	    mov ah,0Eh		; stampamo slovo
	    int 10h		;
	    add dl,2		;
	    inc al		;
	    cmp al,_H		;
	    jle nextmark1	;

	    mov dl,11d		; x koordinata
	    mov dh,19d		; y koordinata
	    mov al,_1		;
nextmark2:  mov ah,02h		; namestamo kursor
	    int 10h		;
	    mov ah,0Eh		; stampamo slovo
	    int 10h		;
	    sub dh,2		;
	    inc al		;
	    cmp al,_8		;
	    jle nextmark2	;

; Crtamo sahovska polja

fields:     mov bh,0		; tacka ima 1. boju
	    mov bl,BOARDFIELD	;
	    mov dx,35d		; DX = y koordinata
nextline29: cmp dx,162d		; da li smo iscrtali poslednju liniju
	    je	stop		; ako jesmo, idemo na kraj
	    mov cx,100d		; ako nismo, vracamo x na pocetak
	    inc dx		; y uvecavamo za jedan
	    mov ax,dx		; Da li treba promeniti boju
	    sub ax,35d		; polja zbog prelaska na sledecu
	    div bl		; liniju kojom pocinje sledeci red
	    cmp ah,0		; sahovske table?
	    jne	nextpixel29	; ne
	    xchg si,di		; da, menja se boja
nextpixel29:mov ax,cx		; Da li treba promeniti boju
	    sub ax,100d		; polja zbog prelaska na sledecu
	    div bl		; tacku kojom pocinje sledeca vrsta
	    cmp ah,0		; sahovske table?
	    jne	samecolor	; ne
	    xchg si,di		; da, menja se boja
samecolor:  mov ax,si		;
	    mov ah,0Ch		; poziv BIOS rutine za crtanje pixela
	    int 10h		;
	    cmp cx,227d		; da li smo iscrtali liniju do kraja
	    je	nextline29	; ako jesmo, idemo na sledecu liniju
	    inc cx		; ako nismo, x uvecavamo za jedan i
	    jmp nextpixel29	; idemo na sledeci pixel

;********** Kraj

stop:	    mov ah,00h		; cekamo na pritisak tastera
	    int 16h		;
	    pop bx		; vracamo stari video mod
	    pop ax		;
	    mov ah,0		;
	    int 10h		;
	    mov	ax, 4C00h	; prekid programa uz vracanje koda za
	    int	21h		; povratak nadredjenom procesu

Code_Seg ENDS


END Start
