; Program za mnozenje dva cela broja duzine do 20 cifara
;
; Autor: Ikodinovic Igor


TITLE Mul


Stack_Seg SEGMENT STACK 'STACK'
		  DW 100 DUP(0) ; Rezervise se 100 reci na steku
	Top_Stack LABEL WORD	; Postavljamo pokazivac na vrh steka (da bi
				; kasnije njim inicijalizovali stek pointer)
Stack_Seg ENDS


Data_Seg SEGMENT WORD 'DATA'
	MAXBUF	      EQU  21
	MAXNUM	      EQU  20
	message1      DB   "Unesite prvi broj  : $"
	message2      DB   "Unesite drugi broj : $"
	message3      DB   "Proizvod           : $"
	messageERR    DB   "Greska! $"
	messageERR1   DB   "Niste uneli nijednu cifru $"
	messageERR2   DB   "Nedozvoljen simbol $"
	messageERR3   DB   "Uneli ste previse cifara $"
	messageERR4   DB   "Sintaksna greska $ "
	Buffer1	      DB   MAXBUF DUP(?)
	Buffer2	      DB   MAXBUF DUP(?)
	Number1	      DB   MAXNUM DUP(?)
	Number2	      DB   MAXNUM DUP(?)
	Result	      DB   2*MAXNUM DUP(?)
	Current       DB   MAXNUM+1 DUP(0)
	LengthBuffer1 DW   0
	LengthBuffer2 DW   0
	LengthNumber1 DW   0
	LengthNumber2 DW   0
	LengthResult  DW   0
	Znak1	      DB   ?
	Znak2	      DB   ?
	ZnakRes       DB   ?
	CursorHome    DW   ?
Data_Seg ENDS


Code_Seg SEGMENT WORD 'CODE'
	ASSUME CS:Code_Seg, DS:Data_Seg, ES:Data_Seg, SS:Stack_Seg

	_BKSPACE EQU 08
	_LF	 EQU 10
	_CR	 EQU 13
	_ENTER	 EQU 13
	_BLANKO	 EQU 32
	_PLUS	 EQU 43
	_MINUS	 EQU 45
	_NULA	 EQU 48
	_DEVET	 EQU 57
	_ESC	 EQU 011Bh
	_HOME	 EQU 4700h
	_LEFT	 EQU 4B00h
	_RIGHT	 EQU 4D00h
	_END	 EQU 4F00h
	_DELETE  EQU 5300h

; Inicijalizacija segmentnih registara i SP

Start:	    mov ax,Stack_Seg	    ; inicijalizacija SS
	    mov ss,ax
	    mov sp,OFFSET Top_Stack ; inicijalizacija SP
	    mov ax,Data_Seg
	    mov ds,ax		    ; inicijalizacija DS
	    mov es,ax		    ; inicijalizacija ES

;********** Unos brojeva i njihovo prevodjenje u odgovarajucu formu

; Unos prvog broja

broj1:	    mov ah,02h		    ; Prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;
	    mov ah,09h		    ; ispis poruke "Unesite prvi broj : "
	    mov dx,OFFSET message1  ; pomocu DOS poziva preko interapta 21h
	    int 21h		    ; i funkcije 09h za ispis stringa

	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    mov CursorHome,dx

	    mov si,0		    ; inicijalizuje tekucu poziciju u bufferu
key_1:	    mov ah,00h		    ; ocitavanje tastera pomocu BIOS poziva preko
	    int 16h		    ; interapta 16h i funkcije 00h (ASCII kod
				    ; znaka je u AL, a u AH je Scan kod)
esckey_1:   cmp ax,_ESC 	    ; da li je pritisnut taster ESC
	    jne homekey_1	    ; ako nije onda idi na homekey_1
	    mov ah,02h		    ;
	    mov dl,_CR		    ;
	    int 21h		    ; prelazak u novi red
	    mov dl,_LF		    ;
	    int 21h		    ;
	    jmp stop
homekey_1:  cmp ax,_HOME	    ; da li je pritisnut taster HOME
	    jne endkey_1	    ; ako nije onda idi na endkey_1
	    mov dx,CursorHome	    ; uzimamo pocetnu poziciju
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h vracamo kursor na pocetnu poziciju
	    mov si,0		    ; vracamo i poziciju u bufferu na pocetak
	    jmp key_1
endkey_1:   cmp ax,_END 	    ; da li je pritisnut taster END
	    jne leftkey_1	    ; ako nije idi na leftkey_1
	    mov dx,CursorHome	    ; uzimamo pocetnu poziciju
	    add dx,LengthBuffer1    ; i racunamo krajnju
	    mov si,LengthBuffer1    ; azuriramo i poziciju u bufferu
	    cmp LengthBuffer1,MAXBUF;
	    jne	goend_1
	    dec dx
	    dec si
goend_1:    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    jmp key_1
leftkey_1:  cmp ax,_LEFT	    ; da li je pritisnut taster LEFT
	    jne rightkey_1	    ; ako nije idi na rightkey_1
	    cmp si,0		    ; ako jeste proveri da li je bafer prazan
	    je	key_1		    ; ako jeste ocitaj sledeci pritisnuti taster
				    ; ako nije pomeri kursor levo:
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    dec dl		    ; smanjujemo za 1 x-koordinatu kursora
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    dec si		    ; azuriramo tekucu poziciju u baferu
	    jmp key_1		    ; idemo na analizu sledeceg pritisnutog tastera
rightkey_1: cmp ax,_RIGHT	    ; da li je pritisnut taster RIGHT
	    jne bkspckey_1	    ; ako nije, idi na bkspckey_1
	    cmp si,LengthBuffer1    ; da li je kursor na kraju tekuceg unosa
	    je	key_1		    ; ako jeste tada ne moze vise desno
	    cmp si,MAXBUF-1	    ; da li je kursor na kraju buffera
	    je	key_1		    ; ako jeste tada ne moze vise desno
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; uvecavamo za 1 x-koordinatu kursora
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    inc si		    ; azuriramo tekucu poziciju u baferu
	    jmp key_1		    ; idemo na analizu sledeceg pritisnutog tastera
bkspckey_1: cmp al,_BKSPACE	    ; da li je pritisnut taster BKSPACE
	    jne delkey_1	    ; ako nije idi na delkey_1
	    cmp si,0		    ; ako jeste proveri da li je bafer prazan
	    je	key_1		    ; ako jeste, ocitaj sledeci pritisnuti taster
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    dec dl		    ; ako nije, sve pomeramo za jedno mesto levo
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor
	    dec si
	    jmp move_1
delkey_1:   cmp ax,_DELETE	    ; da li je pritisnut taster DELETE
	    jne enterkey_1	    ; ako nije idi na enterkey_1
move_1:     push dx		    ; cuvamo poziciju kursora na steku
	    push bx		    ;
	    push si		    ; cuvamo poziciju u bufferu na steku
	    cmp si,LengthBuffer1    ; ako je kursor na kraju tekuceg unosa
	    je	key_1		    ; onda nema brisanja
	    mov ax,si		    ;
	    inc ax		    ;
	    cmp ax,LengthBuffer1    ; ako je kursor na zadnjem unetom znaku
	    je	dellast_1	    ; onda samo obrisi taj znak
moveleft_1: inc si		    ; prepisujemo tekuci znak u bufferu sledecim
	    mov al,Buffer1[si]	    ;
	    dec si		    ;
	    mov Buffer1[si],al	    ;
	    mov ah,0Ah		    ; ispisi znak na mesto kursora pomocu BIOS
	    mov cx,1		    ; poziva preko interapta 10h i funkcije 0Ah
	    int 10h		    ; u CX se pri pozivu upisuje broj ponavljanja
	    inc si		    ; idemo na sledeci znak u bufferu
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; pozicija kursora se pomera udesno
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    mov ax,si		    ;
	    inc ax		    ;
	    cmp ax,LengthBuffer1    ;
	    jl	moveleft_1	    ;
dellast_1:  dec LengthBuffer1	    ; smanjujemo za 1 tekucu duzinu buffera
	    mov al,_BLANKO	    ; brisemo zadnji znak ispisivanjem BLANKO
	    mov ah,0Ah		    ; ispisi znak na mesto kursora pomocu BIOS
	    mov cx,1		    ; poziva preko interapta 10h i funkcije 0Ah
	    int 10h		    ; u CX se pri pozivu upisuje broj ponavljanja
	    pop si		    ; vracamo zapamcene vrednosti
	    pop bx		    ;
	    pop dx		    ;
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h vracamo kursor na zapamcenu poziciju
	    jmp key_1
enterkey_1: cmp al,_ENTER	    ; da li je pritisnut taster ENTER
	    je	syntax_1	    ; ako jeste unos je zavrsen i idi na syntax_1
charkey_1:  cmp al,32		    ; ispitujemo da li je karakter
	    jl	key_1		    ; dozvoljen
	    cmp al,126		    ;
	    jg	key_1		    ;
	    mov ah,0Ah		    ; ispisi znak na mesto kursora pomocu BIOS
	    mov cx,1		    ; poziva preko interapta 10h i funkcije 0Ah
	    int 10h		    ; u CX se pri pozivu upisuje broj ponavljanja
	    mov cl,Buffer1[si]	    ; pamtimo znak na tekucoj poziciji
	    mov Buffer1[si],al	    ; azuriramo buffer
	    cmp LengthBuffer1,MAXBUF; da li je buffer pun
	    jl	label1_1	    ; nije, idi dalje
	    cmp si,MAXBUF-1	    ; da li je kursor na kraju buffera
	    je	key_1		    ; jeste, obradi sledeci taster
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; pozicija kursora se pomera udesno
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    inc si
	    jmp key_1
label1_1:   cmp si,MAXBUF-1	    ; da li je kursor na kraju buffera
	    jl	label2_1	    ; nije, idi dalje
	    inc LengthBuffer1	    ; jeste, samo uvecaj duzinu buffera
	    jmp key_1
label2_1:   cmp si,LengthBuffer1    ; da li je kursor na kraju tekuceg unosa
	    jb	insert_1	    ; nije, idi na insert_1
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; uvecavamo za 1 x-koordinatu kursora
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    inc si		    ; azuriraj tekucu poziciju u baferu
	    inc LengthBuffer1	    ; povecavamo za 1 tekucu duzinu buffera
	    jmp key_1
insert_1:   push dx		    ; cuvamo poziciju kursora na steku
	    push bx		    ;
	    push si		    ; cuvamo poziciju u bufferu na steku
moverght_1: mov al,cl		    ; prepisujemo sledeci znak u bufferu tekucim
	    inc si		    ;
	    mov cl,Buffer1[si]	    ;
	    mov Buffer1[si],al	    ;
	    push cx
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; pozicija kursora se pomera udesno
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    mov ah,0Ah		    ; ispisi znak na mesto kursora pomocu BIOS
	    mov cx,1		    ; poziva preko interapta 10h i funkcije 0Ah
	    int 10h		    ; u CX se pri pozivu upisuje broj ponavljanja
	    pop cx
	    mov ax,si		    ;
	    inc ax		    ;
	    cmp ax,LengthBuffer1    ;
	    jle	moverght_1	    ;
	    inc LengthBuffer1	    ; povecavamo za 1 tekucu duzinu buffera
	    pop si		    ; vracamo zapamcene vrednosti sa steka
	    pop bx		    ;
	    pop dx		    ;
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h vracamo kursor na zapamcenu poziciju
	    inc dl		    ; pozicija kursora se pomera udesno
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    inc si
	    jmp key_1

; Sintaksna analiza
; Ono sto je u Buffer1 se analizira i broj se prepisuje u Number1 ako je
; ispravan, a znak smesta u Znak1. Ako postoji greska ona se prijavljuje.

syntax_1:   mov Znak1,_PLUS
	    mov si,-1
	    mov di,-1
s1_1:	    inc si
	    cmp si,LengthBuffer1    ; da li smo stigli do kraja ucitanog teksta
	    je	error1		    ; ako jesmo skoci na error1
blanko1_1:  cmp Buffer1[si],_BLANKO ; ako je karakter BLANKO
	    je	s1_1		    ; preskoci ga
plus1_1:    cmp Buffer1[si],_PLUS   ; da li je karakter PLUS
	    jne	minus1_1	    ; ako nije skoci na minus1_1
	    mov Znak1,_PLUS	    ; ako jeste zapamti znak i
	    jmp s2_1		    ; skoci na s2_1
minus1_1:   cmp Buffer1[si],_MINUS  ; da li je karakter MINUS
	    jne cifra1_1	    ; ako nije skoci na cifra1_1
	    mov Znak1,_MINUS	    ; ako jeste zapamti znak i
	    jmp	s2_1		    ; skoci na s2_1
cifra1_1:   cmp Buffer1[si],_NULA   ;
	    jl	error2		    ; ako karakter nije ni cifra
	    cmp Buffer1[si],_DEVET  ; prijavi gresku
	    jg	error2		    ;
	    cmp LengthNumber1,MAXNUM; ako je duzina broja veca od zadate
	    je	error3		    ; prijavi gresku
	    inc di		    ; ako nije veca
	    mov al,Buffer1[si]	    ; onda ga
	    mov Number1[di],al	    ; prepisi u Number1
	    inc LengthNumber1	    ; uvecaj duzinu broja
	    jmp s3_1		    ; skoci na s3_1
s2_1:	    inc si
	    cmp si,LengthBuffer1    ; da li smo stigli do kraja ucitanog teksta
	    je	error1		    ; ako jesmo skoci na error1
blanko2_1:  cmp Buffer1[si],_BLANKO ; ako je karakter BLANKO
	    je	s2_1		    ; preskoci ga
cifra2_1:   cmp Buffer1[si],_NULA   ;
	    jl	error2		    ; ako karakter nije ni cifra
	    cmp Buffer1[si],_DEVET  ; prijavi gresku
	    jg	error2		    ;
	    cmp LengthNumber1,MAXNUM; ako je duzina broja veca od zadate
	    je	error3		    ; prijavi gresku
	    inc di		    ; ako nije veca
	    mov al,Buffer1[si]	    ; onda ga
	    mov Number1[di],al	    ; prepisi u Number1
	    inc LengthNumber1	    ; uvecaj duzinu broja
s3_1:	    inc si
	    cmp si,LengthBuffer1    ; da li smo stigli do kraja ucitanog teksta
	    je	broj2		    ; ako jesmo skoci na broj2
blanko3_1:  cmp Buffer1[si],_BLANKO ; ako je karakter BLANKO
	    je	s4_1		    ; skoci na s4_1
cifra3_1:   cmp Buffer1[si],_NULA   ;
	    jl	error2		    ; ako karakter nije ni cifra
	    cmp Buffer1[si],_DEVET  ; prijavi gresku
	    jg	error2		    ;
	    cmp LengthNumber1,MAXNUM; ako je duzina broja veca od zadate
	    je	error3		    ; prijavi gresku
	    inc di		    ; ako nije veca
	    mov al,Buffer1[si]	    ; onda ga
	    mov Number1[di],al	    ; prepisi u Number1
	    inc LengthNumber1	    ; uvecaj duzinu broja
	    jmp s3_1		    ; skoci na s3_1
s4_1:	    inc si
	    cmp si,LengthBuffer1    ; da li smo stigli do kraja ucitanog teksta
	    je	broj2		    ; ako jesmo skoci na broj2
blanko4_1:  cmp Buffer1[si],_BLANKO ; ako je karakter BLANKO
	    je	s4_1		    ; preskoci ga
	    jmp error4		    ; u suprotnom prijavi gresku

; Unos drugog broja

broj2:	    mov ah,02h		    ; Prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;
	    mov ah,09h		    ; ispis poruke "Unesite drugi broj : "
	    mov dx,OFFSET message2  ; pomocu DOS poziva preko interapta 21h
	    int 21h		    ; i funkcije 09h za ispis stringa

	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    mov CursorHome,dx

	    mov si,0		    ; inicijalizuje tekucu poziciju u bufferu
key_2:	    mov ah,00h		    ; ocitavanje tastera pomocu BIOS poziva preko
	    int 16h		    ; interapta 16h i funkcije 00h (ASCII kod
				    ; znaka je u AL, a u AH je Scan kod)
esckey_2:   cmp ax,_ESC		    ; da li je pritisnut taster ESC
	    jne homekey_2	    ; ako nije onda idi na homekey_2
	    mov ah,02h		    ;
	    mov dl,_CR		    ;
	    int 21h		    ; prelazak u novi red
	    mov dl,_LF		    ;
	    int 21h		    ;
	    jmp stop
homekey_2:  cmp ax,_HOME	    ; da li je pritisnut taster HOME
	    jne endkey_2	    ; ako nije onda idi na endkey_2
	    mov dx,CursorHome	    ; uzimamo pocetnu poziciju
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h vracamo kursor na pocetnu poziciju
	    mov si,0		    ; vracamo i poziciju u bufferu na pocetak
	    jmp key_2
endkey_2:   cmp ax,_END		    ; da li je pritisnut taster END
	    jne leftkey_2	    ; ako nije idi na leftkey_2
	    mov dx,CursorHome	    ; uzimamo pocetnu poziciju
	    add dx,LengthBuffer2    ; i racunamo krajnju
	    mov si,LengthBuffer2    ; azuriramo i poziciju u bufferu
	    cmp LengthBuffer2,MAXBUF;
	    jne	goend_2
	    dec dx
	    dec si
goend_2:    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    jmp key_2
leftkey_2:  cmp ax,_LEFT	    ; da li je pritisnut taster LEFT
	    jne rightkey_2	    ; ako nije idi na rightkey_2
	    cmp si,0		    ; ako jeste proveri da li je bafer prazan
	    je	key_2		    ; ako jeste ocitaj sledeci pritisnuti taster
				    ; ako nije pomeri kursor levo:
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    dec dl		    ; smanjujemo za 1 x-koordinatu kursora
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    dec si		    ; azuriramo tekucu poziciju u baferu
	    jmp key_2		    ; idemo na analizu sledeceg pritisnutog tastera
rightkey_2: cmp ax,_RIGHT	    ; da li je pritisnut taster RIGHT
	    jne bkspckey_2	    ; ako nije, idi na bkspckey_2
	    cmp si,LengthBuffer2    ; da li je kursor na kraju tekuceg unosa
	    je	key_2		    ; ako jeste tada ne moze vise desno
	    cmp si,MAXBUF-1	    ; da li je kursor na kraju buffera
	    je	key_2		    ; ako jeste tada ne moze vise desno
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; uvecavamo za 1 x-koordinatu kursora
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    inc si		    ; azuriramo tekucu poziciju u baferu
	    jmp key_2		    ; idemo na analizu sledeceg pritisnutog tastera
bkspckey_2: cmp al,_BKSPACE	    ; da li je pritisnut taster BKSPACE
	    jne delkey_2	    ; ako nije idi na delkey_2
	    cmp si,0		    ; ako jeste proveri da li je bafer prazan
	    je	key_2		    ; ako jeste, ocitaj sledeci pritisnuti taster
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    dec dl		    ; ako nije, sve pomeramo za jedno mesto levo
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor
	    dec si
	    jmp move_2
delkey_2:   cmp ax,_DELETE	    ; da li je pritisnut taster DELETE
	    jne enterkey_2	    ; ako nije idi na enterkey_2
move_2:	    push dx		    ; cuvamo poziciju kursora na steku
	    push bx		    ;
	    push si		    ; cuvamo poziciju u bufferu na steku
	    cmp si,LengthBuffer2    ; ako je kursor na kraju tekuceg unosa
	    je	key_2		    ; onda nema brisanja
	    mov ax,si		    ;
	    inc ax		    ;
	    cmp ax,LengthBuffer2    ; ako je kursor na zadnjem unetom znaku
	    je	dellast_2	    ; onda samo obrisi taj znak
moveleft_2: inc si		    ; prepisujemo tekuci znak u bufferu sledecim
	    mov al,Buffer2[si]	    ;
	    dec si		    ;
	    mov Buffer2[si],al	    ;
	    mov ah,0Ah		    ; ispisi znak na mesto kursora pomocu BIOS
	    mov cx,1		    ; poziva preko interapta 10h i funkcije 0Ah
	    int 10h		    ; u CX se pri pozivu upisuje broj ponavljanja
	    inc si		    ; idemo na sledeci znak u bufferu
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; pozicija kursora se pomera udesno
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    mov ax,si		    ;
	    inc ax		    ;
	    cmp ax,LengthBuffer2    ;
	    jl	moveleft_2	    ;
dellast_2:  dec LengthBuffer2	    ; smanjujemo za 1 tekucu duzinu buffera
	    mov al,_BLANKO	    ; brisemo zadnji znak ispisivanjem BLANKO
	    mov ah,0Ah		    ; ispisi znak na mesto kursora pomocu BIOS
	    mov cx,1		    ; poziva preko interapta 10h i funkcije 0Ah
	    int 10h		    ; u CX se pri pozivu upisuje broj ponavljanja
	    pop si		    ; vracamo zapamcene vrednosti
	    pop bx		    ;
	    pop dx		    ;
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h vracamo kursor na zapamcenu poziciju
	    jmp key_2
enterkey_2: cmp al,_ENTER	    ; da li je pritisnut taster ENTER
	    je	syntax_2	    ; ako jeste unos je zavrsen i idi na syntax_2
charkey_2:  cmp al,32		    ; ispitujemo da li je karakter
	    jl	key_2		    ; dozvoljen
	    cmp al,126		    ;
	    jg	key_2		    ;
	    mov ah,0Ah		    ; ispisi znak na mesto kursora pomocu BIOS
	    mov cx,1		    ; poziva preko interapta 10h i funkcije 0Ah
	    int 10h		    ; u CX se pri pozivu upisuje broj ponavljanja
	    mov cl,Buffer2[si]	    ; pamtimo znak na tekucoj poziciji
	    mov Buffer2[si],al	    ; azuriramo buffer
	    cmp LengthBuffer2,MAXBUF; da li je buffer pun
	    jl	label1_2	    ; nije, idi dalje
	    cmp si,MAXBUF-1	    ; da li je kursor na kraju buffera
	    je	key_2		    ; jeste, obradi sledeci taster
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; pozicija kursora se pomera udesno
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    inc si
	    jmp key_2
label1_2:   cmp si,MAXBUF-1	    ; da li je kursor na kraju buffera
	    jl	label2_2	    ; nije, idi dalje
	    inc LengthBuffer2	    ; jeste, samo uvecaj duzinu buffera
	    jmp key_2
label2_2:   cmp si,LengthBuffer2    ; da li je kursor na kraju tekuceg unosa
	    jb	insert_2	    ; nije, idi na insert_2
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; uvecavamo za 1 x-koordinatu kursora
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    inc si		    ; azuriraj tekucu poziciju u baferu
	    inc LengthBuffer2	    ; povecavamo za 1 tekucu duzinu buffera
	    jmp key_2
insert_2:   push dx		    ; cuvamo poziciju kursora na steku
	    push bx		    ;
	    push si		    ; cuvamo poziciju u bufferu na steku
moverght_2: mov al,cl		    ; prepisujemo sledeci znak u bufferu tekucim
	    inc si		    ;
	    mov cl,Buffer2[si]	    ;
	    mov Buffer2[si],al	    ;
	    push cx
	    mov ah,03h		    ; BIOS pozivom preko interapta 10h i funkcije
	    mov bh,00		    ; 03h ocitamo tekucu poziciju kursora (u dl je
	    int 10h		    ; x-koordinata kursora)
	    inc dl		    ; pozicija kursora se pomera udesno
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    mov ah,0Ah		    ; ispisi znak na mesto kursora pomocu BIOS
	    mov cx,1		    ; poziva preko interapta 10h i funkcije 0Ah
	    int 10h		    ; u CX se pri pozivu upisuje broj ponavljanja
	    pop cx
	    mov ax,si		    ;
	    inc ax		    ;
	    cmp ax,LengthBuffer2    ;
	    jle	moverght_2	    ;
	    inc LengthBuffer2	    ; povecavamo za 1 tekucu duzinu buffera
	    pop si		    ; vracamo zapamcene vrednosti sa steka
	    pop bx		    ;
	    pop dx		    ;
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h vracamo kursor na zapamcenu poziciju
	    inc dl		    ; pozicija kursora se pomera udesno
	    mov ah,02h		    ; BIOS pozivom preko interapta 10h i funkcije
	    int 10h		    ; 02h postavljamo kursor na novu poziciju
	    inc si
	    jmp key_2

; Sintaksna analiza
; Ono sto je u Buffer2 se analizira i broj se prepisuje u Number2 ako je
; ispravan, a znak smesta u Znak2. Ako postoji greska ona se prijavljuje.

syntax_2:   mov Znak2,_PLUS
	    mov si,-1
	    mov di,-1
s1_2:	    inc si
	    cmp si,LengthBuffer2    ; da li smo stigli do kraja ucitanog teksta
	    je	error1		    ; ako jesmo skoci na error1
blanko1_2:  cmp Buffer2[si],_BLANKO ; ako je karakter BLANKO
	    je	s1_2		    ; preskoci ga
plus1_2:    cmp Buffer2[si],_PLUS   ; da li je karakter PLUS
	    jne	minus1_2	    ; ako nije skoci na minus1_2
	    mov Znak2,_PLUS	    ; ako jeste zapamti znak i
	    jmp s2_2		    ; skoci na s2_2
minus1_2:   cmp Buffer2[si],_MINUS  ; da li je karakter MINUS
	    jne cifra1_2	    ; ako nije skoci na cifra1_2
	    mov Znak2,_MINUS	    ; ako jeste zapamti znak i
	    jmp	s2_2		    ; skoci na s2_2
cifra1_2:   cmp Buffer2[si],_NULA   ;
	    jl	error2		    ; ako karakter nije ni cifra
	    cmp Buffer2[si],_DEVET  ; prijavi gresku
	    jg	error2		    ;
	    cmp LengthNumber2,MAXNUM; ako je duzina broja veca od zadate
	    je	error3		    ; prijavi gresku
	    inc di		    ; ako nije veca
	    mov al,Buffer2[si]	    ; onda ga
	    mov Number2[di],al	    ; prepisi u Number2
	    inc LengthNumber2	    ; uvecaj duzinu broja
	    jmp s3_2		    ; skoci na s3_2
s2_2:	    inc si
	    cmp si,LengthBuffer2    ; da li smo stigli do kraja ucitanog teksta
	    je	error1		    ; ako jesmo skoci na error1
blanko2_2:  cmp Buffer2[si],_BLANKO ; ako je karakter BLANKO
	    je	s2_2		    ; preskoci ga
cifra2_2:   cmp Buffer2[si],_NULA   ;
	    jl	error2		    ; ako karakter nije ni cifra
	    cmp Buffer2[si],_DEVET  ; prijavi gresku
	    jg	error2		    ;
	    cmp LengthNumber2,MAXNUM; ako je duzina broja veca od zadate
	    je	error3		    ; prijavi gresku
	    inc di		    ; ako nije veca
	    mov al,Buffer2[si]	    ; onda ga
	    mov Number2[di],al	    ; prepisi u Number2
	    inc LengthNumber2	    ; uvecaj duzinu broja
s3_2:	    inc si
	    cmp si,LengthBuffer2    ; da li smo stigli do kraja ucitanog teksta
	    je	vodecenule	    ; ako jesmo skoci na vodecenule
blanko3_2:  cmp Buffer2[si],_BLANKO ; ako je karakter BLANKO
	    je	s4_2		    ; skoci na s4_2
cifra3_2:   cmp Buffer2[si],_NULA   ;
	    jl	error2		    ; ako karakter nije ni cifra
	    cmp Buffer2[si],_DEVET  ; prijavi gresku
	    jg	error2		    ;
	    cmp LengthNumber2,MAXNUM; ako je duzina broja veca od zadate
	    je	error3		    ; prijavi gresku
	    inc di		    ; ako nije veca
	    mov al,Buffer2[si]	    ; onda ga
	    mov Number2[di],al	    ; prepisi u Number2
	    inc LengthNumber2	    ; uvecaj duzinu broja
	    jmp s3_2		    ; skoci na s3_2
s4_2:	    inc si
	    cmp si,LengthBuffer2    ; da li smo stigli do kraja ucitanog teksta
	    je	vodecenule	    ; ako jesmo skoci na vodecenule
blanko4_2:  cmp Buffer2[si],_BLANKO ; ako je karakter BLANKO
	    je	s4_2		    ; preskoci ga
	    jmp error4		    ; u suprotnom prijavi gresku

; Obrada vodecih nula

vodecenule: mov cx,0		    ; Prvo obradjujemo Number1:
	    mov si,0		    ;
brojnule1:  cmp Number1[si],_NULA   ;
	    jne skininule1	    ;
	    inc si		    ; u petlji se broje vodece nule
	    cmp si,LengthNumber1    ; i njihov broj pamti u cx
	    je	skininule1	    ;
	    inc cx		    ;
	    jmp brojnule1	    ;
skininule1: cmp cx,0		    ; ako nema vodecih nula
	    je	nule2		    ; idi na drugi broj
	    mov di,OFFSET Number1   ; inace se postavljaju destination
	    mov si,di		    ; i source registri za prebacivanje
	    add si,cx		    ; cifara
	    sub LengthNumber1,cx    ; postavlja se nova duzina broja
	    mov cx,LengthNumber1    ; kraca za broj vodecih nula
	    cld 		    ; postavlja se smer pebacivanja
       REP  movsb		    ; petlja za prebacivanje niza cifara

nule2:	    mov cx,0		    ; Sada obradjujemo Number2 na isti nacin
	    mov si,0		    ; kao i kod Number1
brojnule2:  cmp Number2[si],_NULA   ;
	    jne skininule2	    ;
	    inc si		    ;
	    cmp si,LengthNumber2    ;
	    je	skininule2	    ;
	    inc cx		    ;
	    jmp brojnule2	    ;
skininule2: cmp cx,0		    ;
	    je	ASCIItoBIN	    ;
	    mov di,OFFSET Number2   ;
	    mov si,di		    ;
	    add si,cx		    ;
	    sub LengthNumber2,cx    ;
	    mov cx,LengthNumber2    ;
	    cld 		    ;
	REP movsb		    ;

; Prevodjenje ASCII simbola cifara u binarne cifre

ASCIItoBIN: mov si,0		    ; Za Number1:
	    mov cx,LengthNumber1    ;
nextdigit1: sub Number1[si],_NULA   ; oduzima se od ASCII vrednosti cifre
	    inc si		    ; ASCII vrednost nule i ostaje binarna
	    loop nextdigit1	    ; vrednost te cifre

	    mov si,0		    ; Za Number2:
	    mov cx,LengthNumber2    ;
nextdigit2: sub Number2[si],_NULA   ; isto kao gore
	    inc si		    ;
	    loop nextdigit2	    ;

; Brojevi se okrecu, tako da sada cifra najmanje tezine bude na prvom mestu

okreni1:    mov si,OFFSET Number1   ; u SI je adresa cifre najviseg prior.
	    mov di,si		    ;
	    add di,LengthNumber1    ; u DI je adresa cifre najnizeg prior.
	    dec di		    ;
	    mov cx,LengthNumber1    ;
	    shr cx,1		    ; broj zamena = ceo_deo(duzina broja)
	    cmp cx,0
	    je	okreni2
nextturn1:  mov al,[si]		    ; petlja u kojoj se vrsi zamena cifara
	    mov bl,[di] 	    ;
	    mov [si],bl		    ;
	    mov [di],al 	    ;
	    inc si		    ;
	    dec di		    ;
	    loop nextturn1	    ;

okreni2:    mov si,OFFSET Number2   ; Za Number2 je sve isto kao gore
	    mov di,si		    ;
	    add di,LengthNumber2    ;
	    dec di		    ;
	    mov cx,LengthNumber2    ;
	    shr cx,1		    ;
	    cmp cx,0
	    je	mnozenje
nextturn2:  mov al,[si] 	    ;
	    mov bl,[di]		    ;
	    mov [si],bl 	    ;
	    mov [di],al 	    ;
	    inc si		    ;
	    dec di		    ;
	    loop nextturn2	    ;

;********** Mnozenje

mnozenje:   mov di,0		; inicijalizujemo indeks niza Number2
mnozi1:	    mov si,0		; inicijalizujemo indeks niza Number1
	    mov bl,0		; BL=prenos kod mnozenja=0
mnozi2:     mov al,Number1[si]	;
	    mul Number2[di]	; mnozimo tekuce cifre
	    add al,bl		; dodaje se i prenos
	    aam			; AL=niza cifra, AH=visa cifra prizvoda
	    mov Current[si],al	; nizu cifru pisemo u Current
	    mov bl,ah		; prenos pamtimo u BL
	    inc si		; idemo na sledecu cifru
	    cmp si,LengthNumber1; da li je pomnozen ceo broj
	    jl	mnozi2		; ako nije mnozimo sledecu cifru
	    cmp bl,0		; da li je ostao prenos
	    je	saberi		; ako nije idemo na saberi
	    mov Current[si],bl	; ako jeste upisujemo i njega u proizvod

saberi:	    mov cx,si		; inicijalizujemo brojac petlje za sabiranje
	    cmp bl,0		;
	    je	nemaprenos	;
	    inc cx		;
nemaprenos: mov si,di		; postavljamo indeks unutar niza Result
	    mov bp,0		; postavljamo indeks unutar niza Current
	    mov bh,0		; BH=prenos za sabiranje=0
sabiranje:  mov al,Result[si]	; petlja za sabiranje:
	    add al,Current[bp]	; saberi cifre
	    add al,bh		; dodaj i prenos
	    mov bh,0		; prenos=0
	    cmp al,9		; da li ima prenosa
	    jle upisi		; ako nema skoci na upisi
	    sub al,10		; ako ima oduzmi 10 od zbira
	    mov bh,1		; a prenos postavi na 1
upisi:	    mov Result[si],al	; upisi cifru rezultata
	    inc si		;
	    inc bp		;
	    loop sabiranje	;
	    cmp bh,0		; da li postoji prenos na kraju sabiranja
	    je	mnozidalje	; ako ne postoji tada skoci na mnozidalje
	    mov Result[si],bh	; inace ga upisi kao najvisu cifru rezulata

mnozidalje: inc di
	    cmp di,LengthNumber2
	    jl	mnozi1

	    mov cx,LengthNumber1; odredjujemo duzinu proizvoda
	    add cx,LengthNumber2;
	    cmp bl,0		;
	    jne	duzina		;
	    dec cx		;
duzina:     mov LengthResult,cx ;

znak:	    mov bx,LengthResult	;
	    dec bx		;
	    cmp Result[bx],0	; da li je rezultat mnozenja 0
	    jne notzero 	; ako nije onda idi na notzero
	    mov LengthResult,1	; ako jeste onda je duzina 1
	    mov ZnakRes,_PLUS	; dodeljujemo + znak koji se ne ispisuje
	    jmp ispis		;
notzero:    mov al,Znak1	; da li su brojevi
	    cmp al,Znak2	; istog znaka
	    jne	suprznaka	; ako nisu skoci na suprznaka
	    mov ZnakRes,_PLUS	; ako jesu rezultat je pozitivan
	    jmp ispis		;
suprznaka:  mov ZnakRes,_MINUS	; rezultat je negativan

;********** Ispis rezultata

ispis:	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;

	    mov ah,09h		    ;
	    mov dx,OFFSET message3  ; ispis poruke "Proizvod          : "
	    int 21h		    ;

	    cmp ZnakRes,_PLUS	; da li je rezultat pozitivan
	    je	ispisi		; ako jeste ispisi ga
	    mov ah,02h		;
	    mov dl,_MINUS	; ako nije onda prvo ispisi znak -
	    int 21h		;

ispisi:     mov cx,LengthResult ; ispis rezultata
	    mov si,cx		;
	    dec si		;
write:	    mov ah,02h		;
	    mov dl,Result[si]	;
	    add dl,_NULA	;
	    int 21h		;
	    dec si		;
	    loop write		;

	    mov ah,02h		; Prelazak u novi red
	    mov dl,_CR		;
	    int 21h		;
	    mov dl,_LF		;
	    int 21h		;
	    jmp stop

;********** Obrada gresaka

error1:     mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    mov ah,09h		      ;
	    mov dx,OFFSET messageERR  ; ispis poruke "Greska! "
	    int 21h		      ;
	    mov dx,OFFSET messageERR1 ; ispis poruke "Niste uneli nijednu cifru "
	    int 21h		      ;
	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    jmp stop

error2:     mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    mov ah,09h		      ;
	    mov dx,OFFSET messageERR  ; ispis poruke "Greska! "
	    int 21h		      ;
	    mov dx,OFFSET messageERR2 ; ispis poruke "Nedozvoljen simbol "
	    int 21h		      ;
	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    jmp stop

error3:	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    mov ah,09h		      ;
	    mov dx,OFFSET messageERR  ; ispis poruke "Greska! "
	    int 21h		      ;
	    mov dx,OFFSET messageERR3 ; ispis poruke "Uneli ste previse cifara "
	    int 21h		      ;
	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    jmp stop

error4:	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    mov ah,09h		      ;
	    mov dx,OFFSET messageERR  ; ispis poruke "Greska! "
	    int 21h		      ;
	    mov dx,OFFSET messageERR4 ; ispis poruke "Sintaksna greska "
	    int 21h		      ;
	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;

;********** Kraj

stop:	    mov	ax, 4C00h	; prekid programa uz vracanje koda za
	    int	21h		; povratak nadredjenom procesu

Code_Seg ENDS


END Start
