; Program realizuje naredbu za listanje tekuceg direktorijuma uz
; mogucnost koriscenja joker znakova i ima realizovanu opciju /P
; za listanje stranicu po stranicu
;
; Autor: Ikodinovic Igor


TITLE MyDir


Stack_Seg SEGMENT STACK 'STACK'
		  DW 100 DUP(0) ; Rezervise se 100 reci na steku
	Top_Stack LABEL WORD	; Postavljamo pokazivac na vrh steka (da bi
				; kasnije njim inicijalizovali stek pointer)
Stack_Seg ENDS


Data_Seg SEGMENT WORD 'DATA'
	messageERR	DB  "Greska! $"
	messageERR1	DB  "Pogresna sintaksa naredbe $"
	messageERR2	DB  "Nedostaje opcija $"
	messageERR3	DB  "Nepostojeca opcija $"
	messageERR4	DB  "File not found $ "
	messageERR5	DB  "Path not found $ "
	currentdir	DB  64 DUP(?)
	pathname	DB  '*.*                                                             '
	DTA		DB  42 DUP(?)
	filename	DB  9 DUP(?)
	extension	DB  4 DUP(?)
	filesize	DB  4 DUP(0)
	filesizeBCD	DB  8 DUP(?)
	filedate	DB  "  -  -  "
	filetime	DB  "  :  :  "
	messagedir	DB  "Directory of  :\$"
	messagedirsize	DB  "   <DIR>$"
	messagecont	DB  "Continuing  :\$"
	messagepress	DB  "Press any key to continue... $"
	filedir 	DB  ?
	option_P	DB  0
	filesNo 	DB  0
	dirsNo		DB  0
	pagecount	DB  0
	totalfsizeBCD	DB  10 DUP(0)
	diskfree	DB  6 DUP(?)
	diskfreeBCD	DB  10 DUP(0)
	filesreport	DB  "           file(s)                bytes$"
	dirsreport	DB  "           dir(s)                 bytes free$"
Data_Seg ENDS


Code_Seg SEGMENT WORD 'CODE'
	ASSUME CS:Code_Seg, DS:Data_Seg, ES:Data_Seg, SS:Stack_Seg

	_LF	   EQU 10
	_CR	   EQU 13
	_BLANKO    EQU 32
	_ASTERISK  EQU 42
	_TACKA	   EQU 46
	_SLASH	   EQU 47
	_COLON	   EQU 58
	_BACKSLASH EQU 92
	_NULA	   EQU 48
	_velikoA   EQU 65
	_velikoP   EQU 80
	_maloP	   EQU 112
	MAXLINES   EQU 25

; Inicijalizacija segmentnih registara i SP

Start:	    mov ax,Stack_Seg	; inicijalizacija SS
	    mov ss,ax
	    mov sp,OFFSET Top_Stack ; inicijalizacija SP
	    mov ax,Data_Seg
	    mov ds,ax		; inicijalizacija DS
	    mov es,ax		; inicijalizacija ES

;********** Analiza komandne linije

	    mov ah,62h		; poziv DOS rutine za citanje PSP segmentne
	    int 21h		; adrese (smesta se u BX)
	    mov es,bx		; adresa segmenta se stavlja u ES
	    mov cl,es:80h	; u CL je broj znakova u komandnoj liniji
				; (od kraja same komande pa nadalje)
	    mov si,80h		; u SI je relativan pomeraj u odnosu na pocetak
				; PSP. Odatle pocinje tekst komandne linije
				; (od kraja same komande pa nadalje)
	    mov di,0		; inicijalizujemo indeks za pathname string
s1:	    cmp cx,0		; da li smo stigli do kraja linije
	    je	nooptions	; ako jesmo skoci na nooptions
	    inc si		;
	    dec cx		;
	    mov al,es:[si]	;
blanko1:    cmp al,_BLANKO	; ako je karakter BLANKO
	    je	s2		; idi na s2
slash1:	    cmp al,_SLASH	; da li je karakter SLASH
	    je	s5		; ako jeste skoci na s5
	    jmp	error1		; ako nije onda je greska
s2:	    cmp cx,0		; da li smo stigli do kraja linije
	    je	nooptions	; ako jesmo skoci na nooptions
	    inc si		;
	    dec cx		;
	    mov al,es:[si]	;
blanko2:    cmp al,_BLANKO	; ako je karakter BLANKO
	    je	s2		; preskoci ga
slash2:	    cmp al,_SLASH	; da li je karakter SLASH
	    je	s5		; ako jeste skoci na s5
znak2:	    mov pathname[di],al ; dodaj znak u pathname
	    inc di		;
s3:	    cmp cx,0		; da li smo stigli do kraja linije
	    je	nooptions	; ako jesmo skoci na nooptions
	    inc si		;
	    dec cx		;
	    mov al,es:[si]	;
blanko3:    cmp al,_BLANKO	; ako je karakter BLANKO
	    je	s4		; idi na s4
slash3:	    cmp al,_SLASH	; da li je karakter SLASH
	    je	s5		; ako jeste skoci na s5
znak3:	    mov pathname[di],al ; dodaj znak u pathname
	    inc di		;
	    jmp s3		;
s4:	    cmp cx,0		; da li smo stigli do kraja linije
	    je	nooptions	; ako jesmo skoci na nooptions
	    inc si		;
	    dec cx		;
	    mov al,es:[si]	;
blanko4:    cmp al,_BLANKO	; ako je karakter BLANKO
	    je	s4		; preskoci ga
slash4:	    cmp al,_SLASH	; da li je karakter SLASH
	    jne error3		; ako nije onda je greska
s5:	    cmp cx,0		; da li je kraj naredbe
	    je	error2		; ako jeste u pitanju je greska
	    inc si		; ako nije idi na sledeci znak
	    dec cx		;
	    mov al,es:[si]	;
	    cmp al,_maloP	; da li je to znak P
	    je	s6		; ako jeste skoci na s6
	    cmp al,_velikoP	;
	    je	s6		;
	    jmp error3		; ako nije onda je greska
s6:	    cmp cx,0		; da li je kraj naredbe
	    je	optionp 	; ako jeste skoci na optionp
	    inc si		; ako nije idi na sledeci znak
	    dec cx		;
	    mov al,es:[si]	;
	    cmp al,_BLANKO	; da li je to znak BLANKO
	    je	s6		; ako jeste preskoci ga
	    jmp error1		; ako nije onda je greska

;********** Ispis sadrzaja direktorijuma

optionp:    inc option_P	; setujemo option_P fleg

; Ispis imena tekuceg direktorijuma

nooptions:  mov ah,02h		    ; prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;

	    mov ah,47h		    ; get current directory
	    mov dl,0		    ;
	    mov si,OFFSET currentdir; u currentdir cuvamo tekuci direktorijum
	    int 21h		    ;

	    mov ah,19h		    ; get current drive
	    int 21h		    ;

	    add al,_velikoA	    ; ubacujemo ASCII ime drajva
	    mov messagedir[0Dh],al  ; u poruku
	    mov ah,09h		    ; ispisujemo poruku "Directory of  :\"
	    mov dx,OFFSET messagedir; popunjenu sa imenom drajva
	    int 21h		    ;
	    mov ah,02h		    ; ispisujemo ime direktorijuma
	    mov si,0		    ; u nastavku prethodne poruke
write:	    mov dl,currentdir[si]   ;
	    cmp dl,0		    ;
	    je	newline		    ;
	    int 21h		    ;
	    inc si		    ;
	    jmp write		    ;

newline:    mov ah,02h		    ; prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;

; Inicijalizujemo i postavimo sve sto je jos potrebno

	    cmp di,0		    ; da li je unet neki pathname
	    jne add0		    ; ako jeste, skoci na add0
	    mov di,3		    ; ako nije, podrazumeva se *.*

add0:	    mov pathname[di],00h    ; pravimo ASCIIZ pathname, dodajemo 0 na kraj

	    mov dx,OFFSET DTA	    ; postavljamo adresu DTA (Data Transfer Area)
	    mov ah,1Ah		    ;
	    int 21h		    ;

; Trazimo prvi fajl koji se match-uje

	    mov cx,007Fh	    ; atributi = svi fajlovi i direktorijumi
	    mov dx,OFFSET pathname  ; za dati pathname
	    mov ah,4Eh		    ; nadji prvi fajl koji odgovara pathname-u
	    int 21h		    ;

	    jnc	match		    ; ako je pronadjen match skoci
	    cmp ax,02h		    ; ako nije, onda je nesto od sledeceg:
	    je	error4		    ; greska: File not found
	    cmp ax,03h		    ;
	    je	error5		    ; greska: Path not found
	    jmp error4		    ;

; Izdvajamo filename i extension iz DTA podrucja

match:	    mov filedir,0	    ; pretpostavljamo da je file
	    mov al,DTA[15h]	    ; ispitujemo da li je ipak
	    test al,00010000b	    ; direktorijum
	    jz	itsfile		    ; ako nije, onda skacemo na itsfile
	    inc dirsNo		    ; ako jeste, uvecavamo brojac direktorijuma
	    mov filedir,1	    ; postavljamo filedir fleg
	    jmp fname		    ;
itsfile:    inc filesNo 	    ; uvecavamo brojac file-ova

fname:	    mov si,1Eh		    ; izdvajamo filename
	    mov di,0		    ;
nextname:   mov al,DTA[si]	    ;
	    cmp al,0		    ; da li je kraj imena fajla
	    je	noext		    ; ako jeste skoci na noext
	    cmp al,_TACKA	    ; da li je TACKA
	    je	endname		    ; ako jeste idi na endname
	    mov filename[di],al     ;
	    inc si		    ;
	    inc di		    ;
	    jmp nextname	    ;
noext:	    mov filename[di],0	    ; dodajemo 0 na kraj imena
	    mov extension[0],0	    ; nema ekstenzije
	    jmp	fsize		    ; skoci na fsize
endname:    mov filename[di],0	    ; dodajemo 0 na kraj imena

tacka:	    inc si		    ; preskacemo tacku

	    mov di,0		    ; izdvajamo extension
nextext:    mov al,DTA[si]	    ;
	    cmp al,0		    ; da li je kraj ekstenzije
	    je	endext		    ; ako jeste skoci na endext
	    mov extension[di],al    ;
	    inc si		    ;
	    inc di		    ;
	    jmp nextext		    ;
endext:     mov extension[di],0     ; dodajemo 0 na kraj stringa

; Izdvajamo filesize iz DTA podrucja

fsize:	    mov al,DTA[1Ah]	    ; izdvajamo filesize
	    mov filesize[3],al	    ;
	    mov al,DTA[1Bh]	    ;
	    mov filesize[2],al	    ;
	    mov al,DTA[1Ch]	    ;
	    mov filesize[1],al	    ;
	    mov al,DTA[1Dh]	    ;
	    mov filesize[0],al	    ;

	    mov bl,10d		    ; Prevodjenje binarne vrednosti filesize
	    mov si,0		    ; u niz BCD cifara
nextdigit:  mov di,0		    ;
	    mov ah,0		    ;
	    mov cx,4		    ;
nextbyte:   mov al,filesize[di]     ;
	    div bl		    ;
	    mov filesize[di],al     ;
	    inc di		    ;
	    loop nextbyte	    ;
	    mov filesizeBCD[si],ah  ;
	    inc si		    ;
	    cmp si,8		    ;
	    jne nextdigit	    ;

; Izdvajamo filedate iz DTA podrucja

fdate:	    mov bl,DTA[18h]	    ; izdvajamo filedate
	    mov bh,DTA[19h]	    ;
	    mov ax,0000000000011111b; izdvajamo dan
	    and ax,bx		    ;
	    aam 		    ;
	    add ah,_NULA	    ;
	    add al,_NULA	    ;
	    mov filedate[0],ah	    ;
	    mov filedate[1],al	    ;
	    mov ax,0000000111100000b; izvajamo mesec
	    and ax,bx		    ;
	    mov cl,5		    ;
	    shr ax,cl		    ;
	    aam 		    ;
	    add ah,_NULA	    ;
	    add al,_NULA	    ;
	    mov filedate[3],ah	    ;
	    mov filedate[4],al	    ;
	    mov ax,1111111000000000b; izdvajamo godinu
	    and ax,bx		    ;
	    mov cl,9		    ;
	    shr ax,cl		    ;
	    add ax,80d		    ; relativno u odnosu na 1980. godinu
	    aam 		    ;
	    add ah,_NULA	    ;
	    add al,_NULA	    ;
	    mov filedate[6],ah	    ;
	    mov filedate[7],al	    ;

; Izdvajamo filetime iz DTA podrucja

ftime:	    mov bl,DTA[16h]	    ; izdvajamo filetime
	    mov bh,DTA[17h]	    ;
	    mov ax,1111100000000000b; izdvajamo sate
	    and ax,bx		    ;
	    mov cl,11		    ;
	    shr ax,cl		    ;
	    aam 		    ;
	    add ah,_NULA	    ;
	    add al,_NULA	    ;
	    mov filetime[0],ah	    ;
	    mov filetime[1],al	    ;
	    mov ax,0000011111100000b; izvajamo minute
	    and ax,bx		    ;
	    mov cl,5		    ;
	    shr ax,cl		    ;
	    aam 		    ;
	    add ah,_NULA	    ;
	    add al,_NULA	    ;
	    mov filetime[3],ah	    ;
	    mov filetime[4],al	    ;
	    mov ax,0000000000011111b; izdvajamo sekunde
	    and ax,bx		    ;
	    shl ax,1		    ;
	    aam 		    ;
	    add ah,_NULA	    ;
	    add al,_NULA	    ;
	    mov filetime[6],ah	    ;
	    mov filetime[7],al	    ;

; Ispis imena file-a

ispisiname: mov ah,02h		    ; Prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;

	    mov ah,02h		    ; ispis filename-a
	    mov si,0		    ;
write1:     mov dl,filename[si]     ;
	    cmp dl,0		    ;
	    je	ispisiext	    ;
	    int 21h		    ;
	    inc si		    ;
	    jmp write1		    ;

; Ispis ekstenzije file-a

ispisiext:  mov ah,03h		    ; ocitamo tekucu poziciju kursora
	    mov bh,00		    ;
	    int 10h		    ;
	    mov dl,9d		    ; postavljamo kursor na novu poziciju
	    mov ah,02h		    ;
	    int 10h		    ;

	    mov ah,02h		    ; ispis ekstenzije
	    mov si,0		    ;
write2:     mov dl,extension[si]    ;
	    cmp dl,0		    ;
	    je	ispisisize	    ;
	    int 21h		    ;
	    inc si		    ;
	    jmp write2		    ;

; Ispis velicine file-a

ispisisize: cmp filedir,0	    ; da li je direktorijum
	    je	itsfile1	    ; ako nije onda skacemo na itsfile
	    mov ah,03h		    ; ocitamo tekucu poziciju kursora
	    mov bh,00		    ;
	    int 10h		    ;
	    mov dl,12d		    ; postavljamo kursor na novu poziciju
	    mov ah,02h		    ;
	    int 10h		    ;
	    mov ah,09h		    ; inace ispisujemo poruku <DIR> umesto
	    mov dx,OFFSET messagedirsize ; filesize-a, cime obelezavamo
	    int 21h		    ; da je to direktorijum
	    jmp ispisidate	    ; i idemo dalje na ispis datuma

itsfile1:   mov si,7		    ; preskakanje vodecih nula
skipzeros:  cmp filesizeBCD[si],0   ;
	    jne setpos		    ;
	    cmp si,0		    ;
	    je	setpos		    ;
	    dec si		    ;
	    jmp skipzeros	    ;

setpos:	    mov ah,03h		    ; ocitamo tekucu poziciju kursora
	    mov bh,00		    ;
	    int 10h		    ;
	    mov bx,25d		    ; postavljamo kursor na novu poziciju
	    sub bx,si		    ;
	    mov dl,bl		    ;
	    mov ah,02h		    ;
	    int 10h		    ;

	    mov ah,02h		    ; ispis filesize-a
write3:	    mov dl,filesizeBCD[si]  ;
	    add dl,_NULA	    ;
	    int 21h		    ;
	    cmp si,0		    ;
	    je	ispisidate	    ;
	    dec si		    ;
	    jmp write3		    ;

; Ispis datuma

ispisidate: mov ah,03h		    ; ocitamo tekucu poziciju kursora
	    mov bh,00		    ;
	    int 10h		    ;
	    mov dl,28d		    ; postavljamo kursor na novu poziciju
	    mov ah,02h		    ;
	    int 10h		    ;

	    mov ah,02h		    ; ispis filedate-a
	    mov si,0		    ;
	    mov cx,8		    ;
write4:     mov dl,filedate[si]     ;
	    int 21h		    ;
	    inc si		    ;
	    loop write4 	    ;

; Ispis vremena

ispisitime: mov ah,03h		    ; ocitamo tekucu poziciju kursora
	    mov bh,00		    ;
	    int 10h		    ;
	    mov dl,38d		    ; postavljamo kursor na novu poziciju
	    mov ah,02h		    ;
	    int 10h		    ;

	    mov ah,02h		    ; ispis filetime-a
	    mov si,0		    ;
	    mov cx,8		    ;
write5:	    mov dl,filetime[si]     ;
	    int 21h		    ;
	    inc si		    ;
	    loop write5 	    ;

; Uvecavamo totalfsize

	    mov cx,7
	    mov si,0		    ; inicijalizujemo indeks
	    mov bl,0		    ; bl=prenos=0
sabiranje:  mov al,totalfsizeBCD[si]; petlja za sabiranje:
	    add al,filesizeBCD[si]  ; saberi cifre
	    add al,bl		    ; dodaj i prenos
	    mov bl,0		    ; prenos=0
	    cmp al,9		    ; da li ima prenosa
	    jle upisi		    ; ako nema skoci na upisi
	    sub al,10		    ; ako ima oduzmi 10 od zbira
	    mov bl,1		    ; a prenos postavi na 1
upisi:	    mov totalfsizeBCD[si],al; upisi cifru rezultata
	    inc si		    ; uvecaj indeks
	    loop sabiranje	    ;
nextprenos: cmp bl,0		    ; da li postoji prenos
	    je	dooptionP	    ; ako ne, skoci na dooptionP
	    inc al		    ; inace uvecaj cifru
	    mov bl,0		    ; prenos=0
	    cmp al,9		    ; da li ima prenosa od uvecanja
	    jle upisi1		    ; ako nema skoci na upisi1
	    sub al,10		    ; ako ima oduzmi 10 od zbira
	    mov bl,1		    ; a prenos postavi na 1
upisi1:	    mov totalfsizeBCD[si],al; upisi cifru rezultata
	    inc si		    ; uvecaj indeks
	    jmp nextprenos	    ;

; Obradjujemo opciju P

dooptionP:  cmp option_P,0	    ; da li se radi sa opcijom P
	    je	nextmatch	    ; ako ne, skacemo na nextmatch
	    inc pagecount	    ; uvecavamo stranicni brojac
	    mov al,filesNo	    ;
	    add al,dirsNo	    ;
	    cmp al,MAXLINES-3	    ; da li je ovo kraj prve strane
	    je	endofpage	    ; ako jeste skoci na endofpage
	    cmp pagecount,MAXLINES-2; da li je strana puna
	    jl	nextmatch	    ; ako nije, skoci na nextmatch
endofpage:  mov pagecount,0	    ; resetuj stranicni brojac
	    mov ah,02h		    ; prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;
	    mov ah,09h		    ; ispis poruke "Press any key to continue... "
	    mov dx,OFFSET messagepress;
	    int 21h		    ;
	    mov ah,00h		    ; cekamo na pritisak tastera
	    int 16h		    ;

	    mov ah,02h		    ; prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;

	    mov ah,19h		    ; get current drive
	    int 21h		    ;

	    add al,_velikoA	    ; ubacujemo ASCII ime drajva
	    mov messagecont[0Bh],al ; u poruku
	    mov ah,09h		    ; ispisujemo poruku "Continuing  :\"
	    mov dx,OFFSET messagecont; popunjenu sa imenom drajva
	    int 21h		    ;
	    mov ah,02h		    ; ispisujemo ime direktorijuma
	    mov si,0		    ; u nastavku prethodne poruke
write6:	    mov dl,currentdir[si]   ;
	    cmp dl,0		    ;
	    je	nextmatch	    ;
	    int 21h		    ;
	    inc si		    ;
	    jmp write6		    ;

; Trazimo sledeci file koji se match-uje

nextmatch:  mov ah,4Fh		    ; nadji sledeci fajl koji odgovara pathname-u
	    int 21h		    ;
	    jnc	match		    ; ako je pronadjen match skoci

; Ispis broja fajlova i ukupnog njihovog zauzeca memorije na disku

filesrep:   mov al,filesNo	    ; ubacuje se broj fajlova u filesreport
	    aam 		    ;
	    add al,_NULA	    ;
	    mov filesreport[9],al   ;
	    cmp ah,0		    ;
	    je	totalflsz	    ;
	    add ah,_NULA	    ;
	    mov filesreport[8],ah   ;

totalflsz:  mov si,9d		    ; preskacemo vodece nule
skipzeros1: cmp totalfsizeBCD[si],0 ;
	    jne instotflsz	    ;
	    cmp si,0		    ;
	    je	instotflsz	    ;
	    dec si		    ;
	    jmp skipzeros1	    ;
instotflsz: mov di,32d		    ; ubacuje se ukupna velicina svih
	    sub di,si		    ; fajlova iz direktorijuma u filesreport
nexttotalf: mov al,totalfsizeBCD[si];
	    add al,_NULA	    ;
	    mov filesreport[di],al  ;
	    cmp si,0		    ;
	    je	ispisifrep	    ;
	    dec si		    ;
	    inc di		    ;
	    jmp nexttotalf	    ;

ispisifrep: mov ah,02h		    ; prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;

	    mov cx,39d		    ; ispis filesreport-a
	    mov si,0		    ;
write7:	    mov ah,02h		    ;
	    mov dl,filesreport[si]  ;
	    int 21h		    ;
	    inc si		    ;
	    loop write7		    ;

; Ispis broja direktorijuma i kolicina slobodne memorije na disku

dirsrep:    mov al,dirsNo	    ; ubacuje se broj direktorijuma u dirsreport
	    aam 		    ;
	    add al,_NULA	    ;
	    mov dirsreport[9],al    ;
	    cmp ah,0		    ;
	    je	freeondisk	    ;
	    add ah,_NULA	    ;
	    mov dirsreport[8],ah    ;

freeondisk: mov dl,0		    ; AX = sectors per cluster
	    mov ah,36h		    ; BX = number of available clusters
	    int 21h		    ; CX = bytes per sector

	    mul bx		    ; mnozimo AX*BX*CX i rezultat
	    mov bx,dx		    ; se dobija u AX, BX i CX
	    mul cx		    ; pri cemu je u AX rec najvece tezine,
	    mov di,dx		    ; a CX rec najmanje tezine
	    mov si,ax		    ;
	    mov ax,bx		    ;
	    mul cx		    ;
	    mov cx,si		    ;
	    mov bx,di		    ;
	    add bx,ax		    ;
	    mov ax,dx		    ;
	    adc ax,0		    ;
	    mov diskfree[0],ah	    ; iz AX,BX i CX se proizvod prebacuje u
	    mov diskfree[1],al	    ; niz diskfree
	    mov diskfree[2],bh	    ;
	    mov diskfree[3],bl	    ;
	    mov diskfree[4],ch	    ;
	    mov diskfree[5],cl	    ;

	    mov bl,10d		    ; Prevodjenje binarne vrednosti iz diskfree
	    mov si,0		    ; u niz BCD cifara
nextdigit1: mov di,0		    ;
	    mov ah,0		    ;
	    mov cx,6		    ;
nextbyte1:  mov al,diskfree[di]     ;
	    div bl		    ;
	    mov diskfree[di],al     ;
	    inc di		    ;
	    loop nextbyte1	    ;
	    mov diskfreeBCD[si],ah  ;
	    inc si		    ;
	    cmp si,12		    ;
	    jne nextdigit1	    ;

	    mov si,9d		    ; preskacemo vodece nule
skipzeros2: cmp diskfreeBCD[si],0   ;
	    jne insdskfree	    ;
	    cmp si,0		    ;
	    je	insdskfree	    ;
	    dec si		    ;
	    jmp skipzeros2	    ;
insdskfree: mov di,32d		    ; ubacuje se velicina slobodnog prostora
	    sub di,si		    ; na disku u dirsreport
nextdiskfr: mov al,diskfreeBCD[si]  ;
	    add al,_NULA	    ;
	    mov dirsreport[di],al   ;
	    cmp si,0		    ;
	    je	ispisidrep	    ;
	    dec si		    ;
	    inc di		    ;
	    jmp nextdiskfr	    ;

ispisidrep: mov ah,02h		    ; prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;

	    mov cx,44d		    ; ispis dirsreport-a
	    mov si,0		    ;
write8:	    mov ah,02h		    ;
	    mov dl,dirsreport[si]   ;
	    int 21h		    ;
	    inc si		    ;
	    loop write8		    ;

	    mov ah,02h		    ; prelazak u novi red
	    mov dl,_CR		    ;
	    int 21h		    ;
	    mov dl,_LF		    ;
	    int 21h		    ;

	    jmp stop

;********** Obrada gresaka

error1:     mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    mov ah,09h		      ;
	    mov dx,OFFSET messageERR  ; ispis poruke "Greska! "
	    int 21h		      ;
	    mov dx,OFFSET messageERR1 ; ispis poruke "Pogresna sintaksa naredbe "
	    int 21h		      ;
	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    jmp stop

error2:     mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    mov ah,09h		      ;
	    mov dx,OFFSET messageERR  ; ispis poruke "Greska! "
	    int 21h		      ;
	    mov dx,OFFSET messageERR2 ; ispis poruke "Nedostaje opcija "
	    int 21h		      ;
	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    jmp stop

error3:	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    mov ah,09h		      ;
	    mov dx,OFFSET messageERR  ; ispis poruke "Greska! "
	    int 21h		      ;
	    mov dx,OFFSET messageERR3 ; ispis poruke "Nepostojeca opcija "
	    int 21h		      ;
	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    jmp stop

error4:	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    mov ah,09h		      ;
	    mov dx,OFFSET messageERR4 ; ispis poruke "File not found "
	    int 21h		      ;
	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    jmp stop

error5:	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;
	    mov ah,09h		      ;
	    mov dx,OFFSET messageERR5 ; ispis poruke "Path not found "
	    int 21h		      ;
	    mov ah,02h		;
	    mov dl,_CR		;
	    int 21h		; prelazak u novi red
	    mov dl,_LF		;
	    int 21h		;

;********** Kraj

stop:	    mov	ax, 4C00h	; prekid programa uz vracanje koda za
	    int	21h		; povratak nadredjenom procesu

Code_Seg ENDS


END Start
